com.r3corda.core.node.services / UniquenessProvider

# UniquenessProvider

`interface UniquenessProvider`

A service that records input states of the given transaction and provides conflict information if any of the inputs have already been used in another transaction.

### Types

Conflict | `data class Conflict` Specifies the consuming transaction for every conflicting state
ConsumingTx | `data class ConsumingTx` Specifies the transaction id, the position of the consumed state in the inputs, and the caller identity requesting the commit.

### Functions

commit | `abstract fun commit(states: List<StateRef>, txId: SecureHash, callerIdentity: Party): Unit` Commits all input states of the given transaction

### Inheritors

InMemoryUniquenessProvider | `class InMemoryUniquenessProvider : UniquenessProvider` A dummy Uniqueness provider that stores the whole history of consumed states in memory